<?php

//$y = '1333333333333333337';	// 6497282320360345885 (exemple donné)
$y = '8549048879922979409';	// 7364529468137835333 (résultat trouvé)
$ybinstring = '';
$yarraybin = array();
foreach (range(0,62) as $i) {
	$ybinstring .= bcmod($y,2);
	$y = bcdiv($y,2);
}
foreach (str_split($ybinstring,1) as $i=>$ybs)
	$yarraybin[$i] = $ybs === '1';
//var_dump($ybinstring,$yarraybin);
var_dump($ybinstring,$ybinstring[60],$ybinstring[61],$ybinstring[62]);

// y[i+1] = x[i+1] ^ (!x[i] & x[i-1])
// x[i-1]	x[i]	x[i+1]	y[i+1]
// 	0	0	0	0^(1&0)=0
// 	0	0	1	1^(1&0)=1
// 	0	1	0	0^(0&0)=0
// 	0	1	1	1^(0&0)=1
// 	1	0	0	0^(1&1)=1
// 	1	0	1	1^(1&1)=0
// 	1	1	0	0^(0&1)=0
// 	1	1	1	1^(0&1)=1
function evaly(bool $xi, bool $xim1, bool $xim2): bool {
	return (bool)($xi ^ ((!$xim1) && $xim2));
}

$xs = array();	// Possibles valeurs de chaque X
foreach (range(0,62) as $i) {
	$xs[$i] = array(false,true);
}
while (true) {	// Repeat until single value
foreach (range(0+2,62+2) as $i) { // Evite les i négatifs
	$allowedXs = array();
	foreach (range(-2,2) as $j)
		$allowedXs[$j] = array();	// New allowed values
		
	foreach ($xs[$i%63] as $xi) {
	foreach ($xs[($i-2)%63] as $xim2) {
	foreach ($xs[($i-1)%63] as $xim1) {
	foreach ($xs[($i+1)%63] as $xip1) {
	foreach ($xs[($i+2)%63] as $xip2) { // i-2, i-1, i, i+1, i+2
		if (evaly($xi,$xim1,$xim2) === $yarraybin[$i%63]
			&& evaly($xip1,$xi,$xim1) === $yarraybin[($i+1)%63]
			&& evaly($xip2,$xip1,$xi) === $yarraybin[($i+2)%63]) {
			// cette valeur de xi est acceptable
			// '0' ou '1' pour avoir un array unique
			$allowedXs[-2][$xim2?'1':'0'] = $xim2;
			$allowedXs[-1][$xim1?'1':'0'] = $xim1;
			$allowedXs[0][$xi?'1':'0'] = $xi;
			$allowedXs[1][$xip1?'1':'0'] = $xip1;
			$allowedXs[2][$xip2?'1':'0'] = $xip2;
		}
	}
	}
	}
	}
	}
	foreach ($allowedXs as $n=>$a)
		$xs[($i+$n)%63] = array_values($a);
}
$valuesCount = array_map('count',$xs);
foreach ($valuesCount as $i => $vc) {
	if ($vc === 0)
		throw new DomainException("No solution for X$i!");
	else if ($vc === 2)
		continue 2; // Still multiple solutions
}
// All X have 1 single value: solution found!
echo "Solution found:\n";
$x = '';
$xbin = array();
$xdec = '0';
foreach ($xs as $i=>$xx) {
	$xbin[$i] = $xx[0];
	$x .= $xx[0] ? '1' : '0';
	if ($xx[0])
		$xdec = bcadd($xdec,bcpow(2,$i));
}
// Validate solution
// expect xdec=6497282320360345885 for y=1333333333333333337
foreach (range(0+2,62+2) as $i) {
	if (evaly($xbin[$i%63],$xbin[($i-1)%63],$xbin[($i-2)%63])
		!== $yarraybin[$i%63])
		throw new DomainException("Bit $i does not match!");
}

var_dump($x,$xdec);
exit(0);
}
// FCSC{7364529468137835333}


